TYPO3 Core - Bug #49803

Problems in overriding objects with new property mapper
2013-07-09 09:00 - Georg Ringer

Status: Closed Start date: 2013-07-09
Priority: Should have Due date:

Assignee: % Done: 100%
Category: Extbase Estimated time: 0.00 hour
Target version:

TYPO3 Version: 6.2 Complexity:

PHP Version: Is Regression: No

Tags: Sprint Focus:

Description

It seems there is a problem with overriding objects when using the new property mapper.

check this code

config.tx_extbase {

objects {
GeorgRinger\Testoverride\Domain\Model\Fo {
className = GeorgRinger\Testoverride\Domain\Model\Bar

}
}
if the model is used as argument, the "overlay" of Model Bar is missing.

A simple demo extension can be found at: http://montagmorgen.at/fileadmin/tmp/testoverride_0.0.0.zip
Important: the demo exts deactivates the new property mapper in ext_typoscript_setup.txt.

Proof of concept:

1. Install extension and add plugin to a page

2. Create a new record in the FE and fill all fields

3. Disable the new property mapper and add a 2nd record

4. Exception "#1297759968: Exception while property mapping at property path "":Property "test" was not found in target object of
type "GeorgRinger\Testoverride\Domain\Model\Fo"." should be shown.

Related issues:
Related to TYPO3.Flow - Feature #30300: Support mapping to subclass by argument Resolved 2011-09-26
Has duplicate TYPO3 Core - Bug #60705: Property of alternative model implemen... Closed 2014-07-31

Associated revisions

Revision 094ccOc1 - 2014-10-15 23:19 - Oliver Hader

[BUGFIX] Property of alternative model implementation not found

The PersistentObjectConverter is mapping submitted data to a
given target domain model. If a class gets overloaded with
config.tx_extbase.objects, this information is not forwarded

to the ReflectionService. That's why properties in alternative
implementations cannot be determined.

Resolves: #49803

Releases: master, 6.2, 6.1

Change-Id: la4ec3a6c6f5bc6c07717a4956ab12e3e779¢c3c5a
Reviewed-on: http:/review.typo3.org/31920

Reviewed-by: Tymoteusz Motylewski <t.motylewski@gmail.com>
Tested-by: Tymoteusz Motylewski <t.motylewski@gmail.com>
Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>

2021-09-20 1/3



http://montagmorgen.at/fileadmin/tmp/testoverride_0.0.0.zip
http://review.typo3.org/31920
mailto:t.motylewski@gmail.com
mailto:t.motylewski@gmail.com
mailto:klein.t3@reelworx.at
mailto:klein.t3@reelworx.at

Revision 2d0eb56b - 2014-10-15 23:19 - Oliver Hader

[BUGFIX] Property of alternative model implementation not found

The PersistentObjectConverter is mapping submitted data to a
given target domain model. If a class gets overloaded with
config.tx_extbase.objects, this information is not forwarded

to the ReflectionService. That's why properties in alternative
implementations cannot be determined.

Resolves: #49803

Releases: master, 6.2, 6.1

Change-Id: la4ec3a6c6f5bc6c07717a4956ab12e3e779¢c3c5a
Reviewed-on: http://review.typo3.0rg/33327

Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>

Revision 03cb9701 - 2014-10-16 10:25 - Markus Klein
[BUGFIX] Fix unit tests for TypeConverter classes

The patch lad4ec3a6c6f5bc6c07717a4956ab12e3e779c3c5a didn't adjust the
unit tests. This fix adds the missing mocks.

Resolves: #49803

Releases: master, 6.2

Change-Id: 1829e62eaf3b172edeb295da57093b424edb13d40
Reviewed-on: http://review.typo3.org/33330

Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>

Revision 38e34cf3 - 2014-10-16 10:26 - Markus Klein
[BUGFIX] Fix unit tests for TypeConverter classes

The patch ladec3a6c6f5bc6c07717a4956ab12e3e779c3c5a didn't adjust the
unit tests. This fix adds the missing mocks.

Resolves: #49803

Releases: master, 6.2

Change-Id: 1829e62eaf3b172edeb295da57093b424edb13d40
Reviewed-on: http://review.typo3.org/33331

Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>

History

#1 - 2013-07-09 09:02 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22135

#2 - 2013-07-09 10:43 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22135

#3 - 2013-07-09 11:22 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22135

#4 - 2013-10-27 12:48 - Anja Leichsenring

- File testoverride.zip added

#5 - 2014-05-03 21:26 - Marc Bastian Heinrichs

Ok, had a deeper look at this.
What | don't get, is, why you get a Exception from the rewritten PropertyMapper, but you disabled it.

Also I'm not sure, if objectManagers registerlmplemenation is build also for extending models. This will definitly break also in other parts.
Regarding the feature you break with this patch, the backported #30300 - setting a subtype by __type - | would say, this is exactly what you need. But
to make this work the function allowOverrideTargetType in MvcPropertyMappingConfiguration is missing ATM.
#6 - 2014-09-22 17:00 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/31920

#7 - 2014-09-22 17:04 - Alexander Opitz

- Project changed from 534 to TYPO3 Core
- Category set to Extbase

- TYPO3 Version set to 6.2

- Is Regression set to No

#8 - 2014-10-15 21:32 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/31920

#9 - 2014-10-15 23:19 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/33327

#10 - 2014-10-15 23:30 - Oliver Hader
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset 094cc0c13867ebbec7c9ebafea22757ba23a65ch.

#11 - 2014-10-16 09:50 - Mathias Brodala

This change should also allow for using interfaces in controller action arguments if an implementation is registered as usual. Previously the type

converter tried to create an instance of the interface.

#12 - 2014-10-16 10:22 - Gerrit Code Review

- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/33330

#13 - 2014-10-16 10:26 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/33331

#14 - 2014-10-16 10:30 - Markus Klein

- Status changed from Under Review to Resolved

Applied in changeset 03cb9701041da280746d310a7bd2a48241f98a49.

#15 - 2018-10-02 12:12 - Benni Mack

- Status changed from Resolved to Closed

Files

testoverride.zip 997 KB
